#include "GCMotion.h"
#include "string.h"
#include <windows.h>
#include <math.h>
using namespace System;
using namespace System::Windows::Forms;

/*****************************************************************
* Function Name : 指令返回值
* Description   : 返回错误值 rtn
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_rtn_error(short rtn)
{
	if (rtn != RTN_CMD_SUCCESS) {
		MessageBox::Show(Convert::ToString(rtn));
		return rtn;		// 指令执行错误
	}
}

/*****************************************************************
* Function Name : 高级捕获例程
* Description   : 略
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_example(void)
{
	short rtn;					// 指令返回值
	short devNum;				// 设备序号，从0开始
	short axisNum;				// 轴号，从0开始
	HAND devHandle;				// 设备句柄
	HAND axisHandle;			// 轴句柄
	HAND crdHandle;				// 坐标系句柄
	rtn = NMC_DevOpen(devNum, &devHandle);				//打开控制器
	gc_rtn_error(rtn);
	rtn = NMC_MtOpen(devHandle, axisNum, &axisHandle);	//打开轴,并获得轴句柄
	gc_rtn_error(rtn);
	rtn = NMC_MtSetSvOn(axisHandle);					//打开轴使能(根据实际情况使用)
	gc_rtn_error(rtn);

	TAdvCaptureParam advCaptureParam;
	advCaptureParam.capPosIndex = 0;
	advCaptureParam.filter = 100;
	advCaptureParam.trigIndex = 0;
	advCaptureParam.trigSrc = CAPT_EX_SRC_GPI;
	advCaptureParam.trigValue = 0;
	rtn = NMC_MtSetAdvCaptParam(devHandle, &advCaptureParam, 0);//设置高级捕获功能
	gc_rtn_error(rtn);
	/************************* 此处省略轴的运动过程 *****************************/
	short sts;
	long pos[2];
	while (1)
	{
		rtn = NMC_MtGetAdvCaptPos(devHandle, &sts, pos, 0);
		if (sts == 0x3)
		{										//前后沿均已经捕获到
			break;
		}
	}
	return 0;
}
